Attribute VB_Name = "dShow"
Public Declare Function GetCursorPos& Lib "user32" (lpPoint As POINTAPI)
Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public PuntiPressione As POINTAPI
Public PuntiRilascio As POINTAPI
Public pres As Integer

Global DSAudio As IBasicAudio
Global DSVideo As IBasicVideo
Global DSWindow As IVideoWindow
Global DSControl As IMediaControl
Global DSPos As IMediaPosition
Global Const WS_VISIBLE = &H10000000



Sub DS_OpenFile(Filename As String)
    On Error Resume Next
    
    'Puliamo prima di caricare un nuovo file
    Call DS_termina
    
    Set DSControl = New FilgraphManager 'crea il controllo
    Call DSControl.RenderFile(Filename) 'carica il file
    
    'crea il controllo del volume
    Set DSAudio = DSControl
    DSAudio.Volume = 0 'regola il volume come normale
    DSAudio.Balance = 0 'centra l'audio
    
    Set DSWindow = DSControl 'crea l'oggetto che contiene il video
    DSWindow.WindowStyle = &H10000000 'finestra visibile
    DSWindow.Top = 0
    DSWindow.Left = 0
    DSWindow.Width = Form1.Picture1.Width / 15
    DSWindow.Height = Form1.Picture1.Height / 15
    DSWindow.Owner = Form1.Picture1.hWnd
        
    Set DSPos = DSControl 'crea il controllo della posizione
    DSPos.Rate = 1
    
End Sub

Public Sub DS_Play()
    DSPos.CurrentPosition = 0
    Call DSControl.Run
End Sub

Public Sub DS_Pause()
    Call DSControl.Pause
End Sub

Public Sub DS_Riprendi()
    DSControl.Run
End Sub
Public Sub DS_Stop()
    Call DSControl.Stop
    DSPos.CurrentPosition = 0
End Sub


Public Sub DS_SetRate(velocit As Double)
    If velocit <= 0 Then velocit = 0.1
    DSPos.Rate = velocit
End Sub

Public Function DS_GetLen() As Double
    DS_GetLen = DSPos.Duration
End Function

Public Function DS_GetPosition() As Double
    DS_GetPosition = DSPos.CurrentPosition
End Function

Public Sub DS_SetPosition(posizione As Double)
    If posizione > DSPos.Duration Then posizione = DSPos.Duration
    DSPos.CurrentPosition = posizione
End Sub

Public Function DS_GetVolume() As Long
    DS_GetVolume = DSAudio.Volume
End Function

Public Sub DS_SetVolume(Volume As Long)
    If Volume > 0 Then Volume = 0
    If Volume < -10000 Then Volume = -10000
    DSAudio.Volume = Volume
End Sub

Public Function DS_GetBalance() As Long
    DS_GetBalance = DSAudio.Balance
End Function

Public Sub DS_SetBalance(Balance As Long)
    If Balance < -10000 Then Balance = -10000
    If nBalance > 10000 Then Balance = 10000
    DSAudio.Balance = newBalance
End Sub

Public Sub DS_termina()
    On Error Resume Next
    
    'fermiamo il file se sta gi in esecuzione
    DSControl.Stop
    DSWindow.Owner = 0
    'distruggi tutto
    Set DSAudio = Nothing
    Set DSVideo = Nothing
    Set DSControl = Nothing
    Set DSWindow = Nothing
    Set DSPos = Nothing
End Sub
